/******************************************************************************
*
* Copyright (C) 2004-2007, The Gentee Group. All rights reserved. 
* This file is part of the Gentee open source project - http://www.gentee.com. 
* 
* THIS FILE IS PROVIDED UNDER THE TERMS OF THE GENTEE LICENSE ("AGREEMENT"). 
* ANY USE, REPRODUCTION OR DISTRIBUTION OF THIS FILE CONSTITUTES RECIPIENTS 
* ACCEPTANCE OF THE AGREEMENT.
*
* ID: vis.dlgbtns 19.06.09 0.0.A.
*
* Author: Alexander Krivonogov ( gentee )
*
******************************************************************************/

include {
   "btnpic.g"
   "panel.g"
}


type vDlgBtns <inherit = vPanel>
{
   uint    pIndent
   uint    pShowLine
   uint    pShowHelp
   uint    pShowApply
   uint    pShowCancel
   uint    pShowClose
   uint    pShowReady
   uint    pDisableNext
   uint    pWizard
   uint    pCurWizard 
   uint    pMaxWizard
   vPanel  pLine
   vBtnPic btnHelp
   vBtnPic btnCancel
   vBtnPic btnOk
   vBtnPic btnApply
   vBtnPic btnPrev
   vBtnPic btnNext
   vBtnPic btnClose
   evValUint OnApply
   evValUint OnWizard 
       
}

/*define {
// vDlgBtns.Wizard
   dbNone = 0 
   dbFirst = 0x01
   dbMedium = 0x11
   dbLast = 0x10
}*/

/*------------------------------------------------------------------------------
   Internal Methods
*/
method vDlgBtns.iUpdate()
{
   .pLine.Visible = .pShowLine
   .pLine.Left = .pIndent
   .pLine.Right = .pIndent
   
   .btnHelp.Visible = .pShowHelp
   .btnHelp.Left = .pIndent
   
   .btnApply.Visible = .pShowApply   
   
   .btnCancel.Visible = .pShowCancel 
    
   if .pWizard 
   {              
      .btnOk.Caption = "done".ustr()
      .btnPrev.Visible = 1
      .btnPrev.Enabled = .pCurWizard//.pWizard & 0x10
      .btnNext.Visible = .pShowReady || ( .pCurWizard < .pMaxWizard )//(.pWizard & 0x01) 
      .btnNext.Enabled = (!.pDisableNext) && ( .pCurWizard < .pMaxWizard )//(.pWizard & 0x01) && 
      .btnOk.Visible = .pShowReady || !( .pCurWizard < .pMaxWizard )//!(.pWizard & 0x01)
      //.btnOk.Enabled = !.pDisableNext
   }
   else
   {
      .btnOk.Caption = "ok".ustr()
      .btnNext.Visible = 0
      .btnPrev.Visible = 0      
      .btnOk.Visible = !.pShowClose
      .btnClose.Visible = .pShowClose
   }
   
   
   uint right
   if .pShowApply 
   {
      .btnApply.Right = right + .pIndent   
      right = .btnApply.Right + .btnApply.Width
   } 
   if .btnCancel.Visible
   {  
      .btnCancel.Right = right + .pIndent   
      right = .btnCancel.Right + .btnCancel.Width
   }   
   right += .pIndent
   if .btnOk.Visible
   {
      .btnOk.Right = right     
      right = .btnOk.Right + .btnOk.Width
   }
   elif .btnClose.Visible
   {
      .btnClose.Right = right
      right = .btnClose.Right + .btnClose.Width
   }
   if .btnNext.Visible
   {
      .btnNext.Right = right   
      right = .btnNext.Right + .btnNext.Width
   }
   if .btnPrev.Visible
   {
      .btnPrev.Right = right
   }
     
}
   
   
/*------------------------------------------------------------------------------
   Properties
*/
/*  uint vDlgBtns.ShowHelp - Get Set
  help
*/
property uint vDlgBtns.ShowHelp 
{
   return this.pShowHelp
}

property vDlgBtns.ShowHelp( uint val )
{
   if val != this.pShowHelp
   { 
      this.pShowHelp = val
      .iUpdate()
   } 
}   

/*  uint vDlgBtns.ShowApply - Get Set
  apply
*/
property uint vDlgBtns.ShowApply 
{
   return this.pShowApply
}

property vDlgBtns.ShowApply( uint val )
{
   if val != this.pShowApply
   { 
      this.pShowApply = val
      .iUpdate()
   } 
}   

/*  uint vDlgBtns.ShowCancel - Get Set
  cancel
*/
property uint vDlgBtns.ShowCancel 
{
   return this.pShowCancel
}

property vDlgBtns.ShowCancel( uint val )
{
   if val != this.pShowCancel
   { 
      this.pShowCancel = val
      .iUpdate()
   } 
}

/*  uint vDlgBtns.ShowClose - Get Set
  close  cancel
*/
property uint vDlgBtns.ShowClose 
{
   return this.pShowClose
}

property vDlgBtns.ShowClose( uint val )
{
   if val != this.pShowClose
   { 
      this.pShowClose = val
      .iUpdate()
   } 
}         

/*  uint vDlgBtns.ShowLine - Get Set
  help
*/
property uint vDlgBtns.ShowLine
{
   return this.pShowLine
}

property vDlgBtns.ShowLine( uint val )
{
   if val != this.pShowLine
   { 
      this.pShowLine = val
      .iUpdate()
   } 
}

/*  uint vDlgBtns.ShowReady - Get Set
     Wizard
*/
property uint vDlgBtns.ShowReady
{
   return this.pShowReady
}

property vDlgBtns.ShowReady( uint val )
{
   if val != this.pShowReady
   { 
      this.pShowReady = val
      .iUpdate()
   } 
}

/*  uint vDlgBtns.Wizard - Get Set
    
*/
property uint vDlgBtns.Wizard
{
   return this.pWizard
}

property vDlgBtns.Wizard( uint val )
{
   if val != this.pWizard
   { 
      this.pWizard = val
      .iUpdate()
   } 
}

/*  uint vDlgBtns.CurWizard - Get Set
  Wizard
*/
property uint vDlgBtns.CurWizard
{
   return this.pCurWizard
}

property vDlgBtns.CurWizard( uint val )
{
   val == min( val, .pMaxWizard )
   if val != this.pCurWizard
   {  
      this.pCurWizard = val
      .iUpdate()
      evparValUint evp
      evp.val = .pCurWizard
      .OnWizard.Run(evp, this)
   } 
}

/*  uint vDlgBtns.MaxWizard - Get Set
  Wizard
*/
property uint vDlgBtns.MaxWizard
{
   return this.pMaxWizard
}

property vDlgBtns.MaxWizard( uint val )
{
   if val != this.pMaxWizard
   { 
      this.pMaxWizard = val
      .iUpdate()
   } 
}

/*  uint vDlgBtns.DisableNext - Get Set
    
*/
property uint vDlgBtns.DisableNext
{
   return this.pDisableNext
}

property vDlgBtns.DisableNext( uint val )
{
   if val != this.pDisableNext
   { 
      this.pDisableNext = val
      .iUpdate()
   } 
}

/*  uint vDlgBtns.Indent - Get Set
 
*/
property uint vDlgBtns.Indent
{
   return this.pIndent
}

property vDlgBtns.Indent( uint val )
{
   if val != this.pIndent
   { 
      this.pIndent = val
      .iUpdate()
   } 
}

/*------------------------------------------------------------------------------
   Event Processor
*/
method uint vDlgBtns.Ok <alias=vDlgBtns_Ok>( evparEvent evn )
{   
   if !.OnApply.id || .OnApply.Run(evn) : .GetMainForm()->vForm.Result = 1
   return 0
}

method uint vDlgBtns.Wizard <alias=vDlgBtns_Wizard>( evparEvent evn )
{   
   evparValUint evp
   uint val = .pCurWizard
   if evn.sender == &.btnNext : val++
   else : val--
   .CurWizard = val 
   //evp.val = .pCurWizard
   //if !.pCurWizard : .Wizard = $dbFirst
   //else : .Wizard = $dbMedium 
   //.OnWizard.Run(evp, this) 
   return 0
}

method uint vDlgBtns.Cancel <alias=vDlgBtns_Cancel>( evparEvent evn )
{
   .GetMainForm()->vForm.Result = -1   
   return 0
}

method uint vDlgBtns.Help <alias=vDlgBtns_Help>( evparEvent evn )
{   
   .GetForm()->vCtrl.Help()
   return 0
}

method uint vDlgBtns.Apply <alias=vDlgBtns_Apply>( evparEvent evn )
{
   .OnApply.Run( evn )   
   return 0
}

/*------------------------------------------------------------------------------
   Registration
*/

method vDlgBtns vDlgBtns.init( )
{
   this.pTypeId = vDlgBtns
   .pAlign =  $alhClient | $alvBottom
   .loc.height = 60
   .pBorder = $brdNone
   .pShowHelp = 1
   .pShowLine = 1   
   .pShowCancel = 1
   .pIndent = 15
   return this 
}  

method vDlgBtns vDlgBtns.mCreateWin <alias=vDlgBtns_mCreateWin>()
{   
   uint indent = 5
   collection ccaption = %{ "prev", "next", "ok", "cancel", "help", "apply", "close" }
   collection cimage = %{ "", "", "main\\bok", "main\\bcancel", "main\\bhelp", "main\\brefresh", "main\\bcancel" }
   collection cbtn = %{ &.btnPrev, &.btnNext, &.btnOk, &.btnCancel, &.btnHelp, &.btnApply, &.btnClose }
   collection cevent = %{ vDlgBtns_Wizard, vDlgBtns_Wizard, vDlgBtns_Ok, vDlgBtns_Cancel, vDlgBtns_Help, vDlgBtns_Apply, vDlgBtns_Cancel }
   uint i, left 
   this->vPanel.mCreateWin()
   fornum i=0, *cbtn
   {
      uint btn as cbtn[i]->vBtnPic      
      btn.Caption = ccaption[i]->str.ustr()
      btn.Image = cimage[i]->str.ustr()
      btn.VertAlign = $alvCenter      
      btn.Owner = this
      btn.Height = 30 
      btn.OnClick.Set( &this, cevent[i] )
      if &btn != &.btnHelp :  btn.HorzAlign = $alhRight      
   }
   
   .pLine.Top = 0   
   .pLine.Border = $brdLowered
   .pLine.Caption = "".ustr()
   .pLine.HorzAlign = $alhLeftRight
   .pLine.Owner = this
   .pLine.Height = 2
   .Caption = "".ustr()
   .iUpdate()
   return this 
}

func init_vDlgBtns <entry>()
{
   
   regcomp( vDlgBtns, "vDlgBtns", vPanel, $vCtrl_last,        
         %{ %{ $mCreateWin, vDlgBtns_mCreateWin },
            %{ $mSetName,   0 } },
      0->collection )                        
      
ifdef $DESIGNING {
   cm.AddComp( vDlgBtns, 1, "Windows", "dlgbtns" )
   cm.AddProps( vDlgBtns, %{ 
            "ShowLine" , uint, 0,
            "ShowHelp" , uint, 0,
            "ShowApply", uint, 0,
            "ShowCancel", uint, 0,
            "ShowClose", uint, 0,
            "ShowReady", uint, 0,
            "DisableNext", uint, 0,
            "Wizard", uint, 0,
            "Indent"   , uint, 0,
            "CurWizard", uint, 0,
            "MaxWizard", uint, 0
             } )
    cm.AddEvents( vDlgBtns, %{
"OnApply"    , "evparEvent",
"OnWizard"   , "evparValUint"
   } )
   
/*   cm.AddPropVals( vDlgBtns, "Wizard", %{
"dbNone"    ,$dbNone,
"dbFirst"   ,$dbFirst,          
"dbMedium"  ,$dbMedium,   
"dbLast"    ,$dbLast
   })    */
}
} 